<?php

/*
*	Syndeo CMS (former Site@School)
* 	is a website management system designed for primary schools.
* =============================================================================== *
* History Site@School:
* Original idea, coding (version 1.0) and design : Mark de Haan (mark@starwave.nl)
* Ideas, improvements, expansions (versions 1.1 - 2.4): 
* Karin Abma, Dirk Schouten and Fred Stuurman
* Coding version 1.1 - 2.4.10 Fred Stuurman
* =============================================================================== *
* Syndeo CMS Software Version: 2.8.00  
* Copyright (C) 2008: Fred Stuurman (fc.stuurman@hccnet.nl)
* Filemanager for FCK editor:
*  this file is part of the FCK filemanager created for Syndeo cms 
* images.php: last changed 26/02/2009 by Fred Stuurman (fc.stuurman@hccnet.nl)
* $Id$
* =============================================================================== *
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.

* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
* See the GNU General Public License in the starnet directory for more details.
*/

define('IN_SAS', true);

//config of the script
$hide_files = array (
	"^\_t."
); //hide the thumbnails
$create_thumbs = TRUE; //if you don't want thumbs change to FALSE

include ("../../../../../configuration/database.inc.php"); // connecting to database
mysql_connect("$db_server", "$db_username", "$db_password");
mysql_select_db("$db_name");

include ("../../../../../core/common.inc.php");
include ("../../../../../core/session.php");

if ($_SESSION['type'] == "flash")
{
	$allowed_extensions = array (
		"swf",
		"fla"
	);
}
elseif ($_SESSION['type'] == "link")
{
	//get valid file extentions from config table.
	$query = "SELECT config_value FROM $table_configuration WHERE config_key = 'valid_file_extentions'";
	$result = mysql_query($query) ;
	$valid_file_extentions = mysql_result($result, 0);
	
	$allowed_extensions = explode ( "," , $valid_file_extentions) ;
}
elseif ($_SESSION['type'] == "video")
{
	$allowed_extensions = array (
		"wmv",
		"avi",
		"mpeg",
		"mov",
		"asf",
		"mpg"
	);
}
elseif ($_SESSION['type'] == "image")
{
	$allowed_extensions = array (
		"jpg",
		"gif",
		"jpeg",
		"png",
		"tiff",
		"tif",
		"bmp"
	);
}
else
{
	$allowed_extensions = "";
}

$query = "SELECT config_value FROM $table_configuration WHERE config_key = 'serverpath'";
$result = mysql_query($query) ;
$sas_basedir = mysql_result($result, 0);

$query = "SELECT config_value FROM $table_configuration WHERE config_key='file_permissions'";
$result = mysql_query($query) or die_script(mysql_error());
$perm = mysql_result($result, 0);

$query = "SELECT config_value FROM $table_configuration WHERE config_key = 'user_path'";
$result = mysql_query($query) ;
$user_path = mysql_result($result, 0);
if (substr($user_path, 0, 1) == "/")
{
	$user_path = substr($user_path, 1); //strip first slash
}
unset ($query);
unset ($result);

if (IsSet ($_SESSION['userid']) AND (IsSet ($_SESSION['editpage'])))
{
	//when editpage is set we are a pupil or teacher coming using the studenteditor
	//give him/her personal directory

	$query = "SELECT config_value FROM $table_configuration WHERE config_key = 'studentpages_dir'";
	$result = mysql_query($query) ;
	$studentpages = mysql_result($result, 0);
	unset ($query);
	unset ($result);
	$query = "SELECT dir_number FROM $table_studentpages WHERE studentid = '$_SESSION[editpage]'";
	$result = mysql_query($query) ;
	if (mysql_num_rows($result) > 0)
	{
		$dir_number = mysql_result($result, 0); //directory number for the project or pupil
		unset ($query);
		unset ($result);
		// Path to user files relative to the document root.
		$user_path .= "/" . $studentpages . "/" . $dir_number;
		$_SESSION['user_media_path'] = $studentpages . "/" . $dir_number;
	}
}
elseif (($_SESSION['user_type'] == '20') OR ($_SESSION['user_type'] == '22') OR ($_SESSION['user_type'] == '21'))
{
	//we have admin users in S@S admin , present the media directory.
	$user_path .= "/media";
	$_SESSION['user_media_path'] = "media";
}
else
{
	exit; //we don't have a session 
}

$query = "SELECT name FROM $table_users WHERE id = '$_SESSION[userid]'";
$result = mysql_query($query) or die_script(mysql_error());
$user_name = mysql_result($result, 0);

//load language file
$query = "SELECT config_value FROM $table_configuration WHERE config_key = 'language'";
$result = mysql_query($query) or die_script(mysql_error());
$language = mysql_result($result, 0);
include ("../../../../../languages/$language/$language.php");
include ("../../../../../core/file_functions.php");

if (IsSet ($_GET['opendir']))
{
	$user_path = $user_path . $_GET['opendir'] . "/";
	$opendir = $_GET['opendir'];

	if (strpos($opendir, "../") !== false)
	{
		die("Hacking attempt");
	}

	$prev_opendir = dir_name($opendir); //previous opened directory
	$_SESSION['opendir'] = $_GET['opendir']; //this session var is used by browser.php
}
else
{
	$opendir = ""; //make sure its cleared 
}

if (IsSet ($_GET['delete_file']))
{

	$delete_file = $_GET['delete_file'];
	if (strpos($delete_file, "../") !== false)
	{
		die("Hacking attempt");
	}

	$file = $sas_basedir . $user_path . $delete_file;

	if (file_exists($file)) //if file exists, delete it.
	{
		unlink($file);
	}

	$thumbfile = $sas_basedir . $user_path . '_thumbs/_' . $delete_file;

	if (file_exists($thumbfile)) //if thumb exists, delete it.
	{
		unlink($thumbfile);
	}
}

if (substr($user_path, -2) == "//") //prevent double slash
{
	$user_path = substr($user_path, 0, -1);
}
?>
<html>
	<head>
		<title><?PHP echo $sas_lang['insert_picture'] ?></title>

<style type="text/css">
<!--
body, td, input, select
{
	margin:0px; padding:0px;
	font-size: 11px;
	font-family: 'Microsoft Sans Serif' , Arial, Helvetica, Verdana;
}

A:link {color: #000000; text-decoration: none}

A:active {color: #000000; text-decoration: none}

A:visited {color: #000000; text-decoration: none}

A:hover {color: #07367a; text-decoration: none}

.imgBorder {
	height: 110px;
	border: 1px solid threedface;
	vertical-align: middle;
}

.imgBorderHover {
	height: 110px;
	border: 1px solid threedface;
	vertical-align: middle;
	background: #FFFFCC;
	cursor: hand;
}

.title { background: #ddf; color: #000; font-weight: bold; font-size: 120%; padding: 3px 10px; margin-bottom: 10px;
border-bottom: 1px solid black; letter-spacing: 2px;

}
-->
</style>
</head>
<body>
<script type="text/javascript">
        
function SelectFile( fileUrl )
{
        parent.window.opener.SetUrl( fileUrl ) ;
        parent.window.close() ;
}

</script>
<?php

print "<table cellspacing=\"2\" cellpadding=\"0\" width=\"100%\" border=\"0\">
		<tr><td colspan=\"6\">" . $sas_lang['username'] . ": <b>" . $user_name . "</b> - " . $sas_lang['directory'] . "&nbsp;<b>" . $user_path . "</b></td></tr><tr>\n";

//define arrays were file and directories are stored
$files = array ();
$dirs = array ();

if ($dh = opendir($sas_basedir . $user_path))
{
	while (($filename = readdir($dh)) !== false) //read the directory via file handle
	{
		//skip special directories as "gallery" and "downloads"
		if (($filename != ".") && ($filename != "..") && ($filename != "downloads") && ($filename != "templates") && ($filename != "video") &&(!preg_match("/_t./", $filename))) 
		{
			if (is_dir($sas_basedir . $user_path . "$filename")) //is entry a directory
			{
				array_push($dirs, $filename);
			}
			else //entry is a file 
			{
				$lastdot = strrpos($filename, ".");
				$ext = (($lastdot !== false) ? (substr($filename, $lastdot +1)) : "");
				$hide = false;

				for ($j = 0; $j < sizeof($hide_files); $j++)
					$hide = (ereg($hide_files[$j], $filename) ? true : $hide);

				if ((in_array(strtolower($ext), $allowed_extensions)) AND (!$hide)) //allowed file type and not hidden
				{
					array_push($files, $filename);
				}
			}
		}
	}
	closedir($dh);
}
//sort the dirs and files arrays
$array_lowercase = array_map('strtolower', $dirs);
array_multisort($array_lowercase, SORT_ASC, SORT_STRING, $dirs);
$array_lowercase = array_map('strtolower', $files);
array_multisort($array_lowercase, SORT_ASC, SORT_STRING, $files);

//list the directories
$i = 0;
if (($_GET['opendir'] != "/") AND ($_GET['opendir'] != ""))
{
	//create a return icon for previous directory
	print "<td width=\"20%\" align=\"center\" class=\"imgBorder\">
			<a href=\"images.php?opendir=" . $prev_opendir . "\"><img src=\"graphics/previous.png\" border=\"0\"><br>" . $sas_lang['goback'] . " ..</a></td>\n";
	$i++;
}

foreach ($dirs as $value) //list the directory array
{
	if ($_GET['opendir'] != "/")
	{
		$path = $_GET[opendir] . "/" . $value;
	}
	else
	{
		$path = $value;
	}
	if (substr($path, 0, 1) != "/") //check if first pos is a slash, if not add it.
	{
		$path = "/" . $path;
	}
	print "<td width=\"20%\" align=\"center\" class=\"imgBorder\">
			<a href=\"images.php?opendir=$path\"><img src=\"graphics/folder.gif\" border=\"0\"><br>" . $value . "</a></td>\n";
	$i++;

	if ($i == 5)
	{
		print "</tr><tr>";
		$i = 0;
	}

}

// print empty cells if needed.
for ($k = $i; $k <= 4; $k++)
{
	echo "<td width=\"20%\">&nbsp;</td>";
}

if ($i < 4)
{
	print "</tr>";
}

//list the files
$i = 0;

print "<tr>";
foreach ($files as $value) //list the files array
{
	$tmp = explode(".", $value); //get the picture extention.
	$ext = array_pop($tmp);
	$thumb = FALSE;

	if ((strtoupper($ext) == "PNG") or (strtoupper($ext) == "GIF") or (strtoupper($ext) == "JPG"))
	{
		make_thumb($sas_basedir . $user_path . $value, 96 , "_t");
		$image_file = "/" . $user_path . make_thumb_name($value, "_t") ;
	}
	elseif ((strtoupper($ext) == "DOC") or (strtoupper($ext) == "TXT"))
	{
		$image_file = "graphics/document.jpg";
	}
	elseif (strtoupper($ext) == "XLS")
	{
		$image_file = "graphics/spreadsheet.jpg";
	}
	elseif ((strtoupper($ext) == "SWF") or (strtoupper($ext) == "FLA") or (strtoupper($ext) == "MPG")  or (strtoupper($ext) == "WMV") or (strtoupper($ext) == "AVI") or (strtoupper($ext) == "MPEG"))
	{
		$image_file = "graphics/video.jpg";
	}
	elseif (strtoupper($ext) == "PDF")
	{
		$image_file = "graphics/pdf.jpg";
	}
	elseif ((strtoupper($ext) == "MP3") or (strtoupper($ext) == "WAV"))
	{
		$image_file = "graphics/sound.jpg";
	}
	elseif ((strtoupper($ext) == "HTML") or (strtoupper($ext) == "HTM"))
	{
		$image_file = "graphics/html.jpg";
	}
	elseif (strtoupper($ext) == "ZIP")
	{
		$image_file = "graphics/tar.jpg";
	}
	else
	{
		$image_file = "graphics/binary.jpg";
	}

	print "<td align=\"center\" class=\"imgBorder\" width=\"96\" height=\"96\"><a href=\"javascript:SelectFile('/" . $user_path . $value . "');\">";

	if (file_exists($sas_basedir.$image_file))
	{
		print "<img src=\"" . $image_file . "\" border=\"0\" alt=\"$value\" title=\"$value\"></a><br>\n" . $value . "<br>";
	}
	else
	{
		print "<img src=\"/" . $user_path . $value . "\" width=\"96\" height=\"96\" border=\"0\" alt=\"$value\" title=\"$value\"></a><br>\n" . $value . "<br>";
	}

	if (IsSet ($_GET['opendir'])) //if we are in a subdirectory we need to add it to the link
	{
		$delete_link = "images.php?opendir=" . $_GET['opendir'] . "&delete_file=" . $value;
	}
	else
	{
		$delete_link = "images.php?delete_file=" . $value;
	}
	
	$delete_file_confirmation = str_replace("%object%", $value, $sas_lang['delete_file_confirmation']);
	print "<img border=\"0\" src=\"graphics/delete.gif\" width=\"16\" height=\"16\" alt=\"" . $sas_lang['delete'] . "\" title=\"" . $sas_lang['delete'] . "\"
				onClick=\"if(confirm('" . $delete_file_confirmation . "')) parent.images.location='$delete_link';\"></a></td>\n";
	$i++;
	if ($i == 5)
	{
		print "</tr><tr>";
		$i = 0;
	}
}

if ($i > 0)
{
	for ($k = $i; $k <= 4; $k++)
	{
		echo "<td width=\"20%\">&nbsp;</td>";
	}
}

if ($i < 4)
{
	print "</tr>";
}

print "</table>";
print "</body>
</html>";


function dir_name($dir)
{
	# strip the last directory to be able to jump back to the previous directory.
	$lastSlash = intval(strrpos($dir, '/'));

	if ($lastSlash == 0)
	{
		return "/";
	}
	else
		return dirname($dir);
}
?>